% We throw a coin 2 times.
% The result of the second throw is independent of the first throw
% We test it ntests = 1000 times and plot the distribution of the pvalues and the statistics

nsamples = 100;
ntests = 10000;

X2 = zeros(1,ntests);
pvalues = zeros(1,ntests);

for t = 1:ntests
    O = zeros(2,2);
    for i = 1:nsamples
        r1 = rand();
        r2 = rand();
        
        if(r1 < 0.5 && r2 < 0.5)
            O(1,1) = O(1,1) + 1;
        elseif(r1 < 0.5 && r2 >= 0.5)
            O(1,2) = O(1,2) + 1;
        elseif(r1 >= 0.5 && r2 < 0.5)
            O(2,1) = O(2,1) + 1;
        else
            O(2,2) = O(2,2) + 1;
        end
    end
    E = zeros(2,2);
    for i = 1:2
        for j = 1:2
            E(i,j) = sum(O(i,:)) * sum(O(:,j)) / nsamples;
        end
    end
    
    X2(t) = sum(sum((O - E).^2 ./ E));
    pvalues(t) = 1 - chi2cdf(X2(t),1);
end

figure,hist(X2,50);
figure,hist(pvalues,49);
